/**
  ******************************************************************************
  * @file    vks118.c
  * @author  kevin_guo
  * @version V1.2
  * @date    05-17-2020
  * @brief   This file contains all the vks118 functions. 
	*          ļ VKS118
  ******************************************************************************
  * @attention
  ******************************************************************************
  */	
/* Includes ------------------------------------------------------------------*/
#include "vks118.h"
  
/* extern variables ----------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define VKS118_CLK 10 //WRźƵ,delay_nusʵ 50->10kHz 10->50kHz 5->100kHz
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
//segtab[]ӦʵʵоƬLCDߣ߼-VKS118ο·
unsigned char vks118_segtab[VKS118_SEGNUM]={
	 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,			//SEG0-SEG19
	20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,			//SEG20-SEG39
	40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,			//SEG40-SEG59
	60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,			//SEG60-SEG79
	80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,			//SEG80-SEG99
	100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,		//SEG100-SEG117	
};
//LCDʵֻSEG10SEG21ʹ
//.hļVKS118_SEGNUM=12
//const unsigned char vks118_segtab[VKS118_SEGNUM]={	
//	10,11,12,13,14,15,16,17,18,19,	//SEG10-SEG19
//	20,21,													//SEG20-SEG21
//};
//vks118_dispramӦоƬʾRAM
unsigned char vks118_dispram[VKS118_SEGNUM];
//Ӧvks118_segtab[VKS118_SEGNUM]
//ʾRAM bufferֻʹõ4λbit0->com0,bit1->com1,bit2->com2,bit3->com3
//LCD ʵ  38
//1ǰλ2ʮλ3Ǹλ
/*ʾbufferlcdͼӳϵ
/0BIAS 100%DUTY
vks118_dispram[VKS118_SEGNUM]=
{//com1     com0 //ӦоƬSEG  ӦʾRAM
	1E,      1E,     //seg2   			vks118_dispram[1]-bit1
	1F,      1F,     //seg3   			vks118_dispram[1]-bit0
	1G,      1G,     //seg4					vks118_dispram[2]-bit1
	1A,      1A,     //seg5					vks118_dispram[2]-bit0
	1C,      1C,     //seg6					vks118_dispram[3]-bit1
	1B,      1B,     //seg7					vks118_dispram[3]-bit0
	1D,      1D,     //seg8					vks118_dispram[4]-bit1
	P1,      P1,     //seg9					vks118_dispram[4]-bit0
	2E,      2E,     //seg12   			vks118_dispram[6]-bit1
	2F,      2F,     //seg13   			vks118_dispram[6]-bit0
	2G,      2G,     //seg14				vks118_dispram[7]-bit1
	2A,      2A,     //seg15				vks118_dispram[7]-bit0
	2C,      2C,     //seg16				vks118_dispram[8]-bit1
	2B,      2B,     //seg17				vks118_dispram[8]-bit0
	2D,      2D,     //seg18				vks118_dispram[9]-bit1
	P2,      P2,     //seg19				vks118_dispram[9]-bit0
	3E,      3E,     //seg22   			vks118_dispram[11]-bit1
	3F,      3F,     //seg23   			vks118_dispram[11]-bit0
	3G,      3G,     //seg24				vks118_dispram[12]-bit1
	3A,      3A,     //seg25				vks118_dispram[12]-bit0
	3C,      3C,     //seg26				vks118_dispram[13]-bit1
	3B,      3B,     //seg27				vks118_dispram[13]-bit0
	3D,      3D,     //seg28				vks118_dispram[14]-bit1
	P3,      P3,     //seg29				vks118_dispram[14]-bit0
}
*/
/*8ֵ 
      4A
   6F    2B
      5G
	 7E    3C
	    1D    0dot
*/
unsigned char shuzi_zimo[15]= //ַֺģ
{
//0    1    2    3    4    5    6    7    8    9    -    L    o    H    i 
	0xDE,0x06,0xB6,0x3E,0x6C,0x7A,0xFA,0x1C,0xFE,0x7E,0x20,0xC2,0xAA,0xEC,0x06
};
unsigned char vks118_addrbit=6;//icramַA5-A0,
unsigned char vks118_segi,vks118_comi;
unsigned char vks118_maxcom;//com4com3com2com
//ʾRAM bufferֻʹõ4λ
//M0=0 bit0->com0,bit1->com0,bit2->com0,bit3->com0
//M1=0 bit0->com0,bit1->com1,bit2->com0,bit3->com1
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/
/*******************************************************************************
* Function Name  : delay_nus
* Description    : ʱ1uS
* Input          : n->ʱʱnuS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}
/*******************************************************************************
* Function Name  : delay_nms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nms(unsigned long int n)
{
	while(n--)
	{
		delay_nus(1000);
	}
}
/*******************************************************************************
* Function Name  : WriteClock
* Description    : WRʱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void WriteClockVks118(void)
{
	VKS118_WR_L(); 
	delay_nus(VKS118_CLK);
	VKS118_WR_H();	
	delay_nus(VKS118_CLK);	
}
/*******************************************************************************
* Function Name  : WriteCommand
* Description    : д
* Input          : FunctonCode->/ 
* Output         : None
* Return         : None
*******************************************************************************/
void WriteCommandVks118(unsigned char FunctonCode)
{
	unsigned char Shift = 0x80; 
	unsigned char i;
	
	VKS118_CS1_L();   //CS Ƭѡ   
	delay_nus(VKS118_CLK/2);
	VKS118_DATA_H();  
	WriteClockVks118();
	VKS118_DATA_L();  
	WriteClockVks118();
	VKS118_DATA_L();  
	WriteClockVks118();

	for(i = 0; i < 8; i++) 
	{
	 if(Shift & FunctonCode) 	
		 VKS118_DATA_H(); 
	 else 
		 VKS118_DATA_L();	  

	 WriteClockVks118();
	 Shift = Shift >> 1;
	}
  VKS118_DATA_L(); 
	WriteClockVks118();	//һ0һλ X
  VKS118_CS1_H(); 			//CS Ƭѡ  
	delay_nus(VKS118_CLK/2);
  VKS118_DATA_H(); 
}

/*******************************************************************************
* Function Name  : Write1Data
* Description    : д1SEGݵʾRAMbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* Input          : Addr->дramĵַ  
* 							 : Databuf->дram(1ֽݵ4λЧ)  
* Output         : None
* Return         : None
*******************************************************************************/
void Write1DataVks118_CS1(unsigned char Addr,unsigned char Dat)
{
	unsigned char i; 
	unsigned char Shift;
	
	Shift = 0x20; //θ3λ ֻ5λ
	
	VKS118_CS1_L();  //CS Ƭѡ
	delay_nus(VKS118_CLK/2);

	VKS118_DATA_H();  
	WriteClockVks118();  //101
	VKS118_DATA_L();  
	WriteClockVks118();
	VKS118_DATA_H();  
	WriteClockVks118();

	for( i = 0; i < vks118_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VKS118_DATA_H(); 		
		else  
			VKS118_DATA_L();
		WriteClockVks118();		
		Shift = Shift >> 1; 
	}
  Shift = 0x01;
  for (i = 0; i < 4; i++) 
	{

		if( Dat & Shift) 
			VKS118_DATA_H();		 
   	else  
			VKS118_DATA_L();
		WriteClockVks118();
		Shift = Shift << 1;
	}   
  VKS118_CS1_H(); //CS Ƭѡ
	delay_nus(VKS118_CLK/2);	
  VKS118_DATA_H(); 
}
void Write1DataVks118_CS2(unsigned char Addr,unsigned char Dat)
{
	unsigned char i; 
	unsigned char Shift;
	
	Shift = 0x20; //θ3λ ֻ5λ
	
	VKS118_CS2_L();  //CS Ƭѡ
	delay_nus(VKS118_CLK/2);

	VKS118_DATA_H();  
	WriteClockVks118();  //101
	VKS118_DATA_L();  
	WriteClockVks118();
	VKS118_DATA_H();  
	WriteClockVks118();

	for( i = 0; i < vks118_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VKS118_DATA_H(); 		
		else  
			VKS118_DATA_L();
		WriteClockVks118();		
		Shift = Shift >> 1; 
	}
  Shift = 0x01;
  for (i = 0; i < 4; i++) 
	{

		if( Dat & Shift) 
			VKS118_DATA_H();		 
   	else  
			VKS118_DATA_L();
		WriteClockVks118();
		Shift = Shift << 1;
	}   
  VKS118_CS2_H(); //CS Ƭѡ
	delay_nus(VKS118_CLK/2);	
  VKS118_DATA_H(); 
}
/*******************************************************************************
* Function Name  : WritenData
* Description    : дnSEGݵʾRAMbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* Input          : Addr->дramʼַ  
* 							 : Databuf->дramָ(ÿֽݵ4λЧ)  
* 							 : Cnt->дramݸ
* Output         : None
* Return         : None
*******************************************************************************/
void WritenDataVks118_CS1(unsigned char Addr,unsigned char *Databuf,unsigned char Cnt)
{
	unsigned char i,j; 
	unsigned char Shift;
	unsigned char dataval; 
	
	VKS118_CS1_L();   //CS Ƭѡ 
	delay_nus(VKS118_CLK/2);

	VKS118_DATA_H();  
	WriteClockVks118();  //101
	VKS118_DATA_L();  
	WriteClockVks118();
	VKS118_DATA_H();  
	WriteClockVks118();

	Shift = 0x20;
	for( i = 0; i < vks118_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VKS118_DATA_H(); 		
		else  
			VKS118_DATA_L();
		WriteClockVks118();		
		Shift = Shift >> 1; 
	}
	for (j = 0; j < Cnt; j++) 
	{
		Shift = 0x01;
		dataval=*Databuf++;
		for (i = 0; i < 4; i++) 
		{
			if( dataval & Shift) 
				VKS118_DATA_H();		 
			else  
				VKS118_DATA_L();
			WriteClockVks118();
			Shift = Shift << 1;
		}   
	}
  VKS118_CS1_H();   //CS Ƭѡ
	delay_nus(VKS118_CLK/2);	 
  VKS118_DATA_H(); 
}
void WritenDataVks118_CS2(unsigned char Addr,unsigned char *Databuf,unsigned char Cnt)
{
	unsigned char i,j; 
	unsigned char Shift;
	unsigned char dataval; 
	
	VKS118_CS2_L();   //CS Ƭѡ 
	delay_nus(VKS118_CLK/2);

	VKS118_DATA_H();  
	WriteClockVks118();  //101
	VKS118_DATA_L();  
	WriteClockVks118();
	VKS118_DATA_H();  
	WriteClockVks118();

	Shift = 0x20;
	for( i = 0; i < vks118_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VKS118_DATA_H(); 		
		else  
			VKS118_DATA_L();
		WriteClockVks118();		
		Shift = Shift >> 1; 
	}
	for (j = 0; j < Cnt; j++) 
	{
		Shift = 0x01;
		dataval=*Databuf++;
		for (i = 0; i < 4; i++) 
		{
			if( dataval & Shift) 
				VKS118_DATA_H();		 
			else  
				VKS118_DATA_L();
			WriteClockVks118();
			Shift = Shift << 1;
		}   
	}
  VKS118_CS2_H();   //CS Ƭѡ
	delay_nus(VKS118_CLK/2);	 
  VKS118_DATA_H(); 
}
/*******************************************************************************
* Function Name  : Vks118_DisAll
* Description    : SEGʾͬһݣbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* 					     : 磺0x0fȫ 0x00ȫ 0x05 0x0a 0x03 
* Input          dat->дram(1ֽݵ4λЧ)  
* Output         : None
* Return         : None
*******************************************************************************/
void Vks118_DisAll(unsigned char dat)
{
	unsigned char segi;
	unsigned char dispram[32];
	
//̬
	for(segi=0;segi<32;segi++)
	{
		dispram[segi]=dat;
	}
	WritenDataVks118_CS1(0,dispram,32);//4bitַԶ1
	for(segi=0;segi<27;segi++)
	{
		dispram[segi]=dat;
	}
	WritenDataVks118_CS2(0,dispram,27);//4bitַԶ1
}
/*******************************************************************************
* Function Name  : DisSegComOn
* Description    : 1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vks118_DisSegComOn(unsigned char seg,unsigned char com)
{	
	unsigned char dispram=0;
	
//̬
	if((seg%2)==0)
		dispram|=0x02;
	else if((seg%4)==1)
		dispram|=0x01;
	if(seg<64)
		Write1DataVks118_CS1(seg/2,dispram);
	else
		Write1DataVks118_CS2(seg/2,dispram);
}
/*******************************************************************************
* Function Name  : DisSegComOff
* Description    : ر1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vks118_DisSegComOff(unsigned char seg,unsigned char com)
{
	unsigned char dispram=0;
	
//̬
	if((seg%2)==0)
		dispram&=~0x02;
	else 
		dispram&=~0x01;
	if(seg<64)
		Write1DataVks118_CS1(seg/2,dispram);
	else
		Write1DataVks118_CS2(seg/2,dispram);
}
/*******************************************************************************
* Function Name  : Enter_Standby
* Description    : ͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vks118_Enter_Standby(void)
{	
	//ʹLCDOFFSYSDIS,ϵͳڵ͹״̬
	//ֻʹƬRCʱԴʱ,ʹϵͳ͹״̬
	WriteCommandVks118(OSC_OFF);
	WriteCommandVks118(DISP_OFF);
}
/*******************************************************************************
* Function Name  : Exit_Standby
* Description    : ˳͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vks118_Exit_Standby(void)
{	
	//˳͹״̬vks118
	WriteCommandVks118(OSC_ON);
	WriteCommandVks118(DISP_ON);
}
/*******************************************************************************
* Function Name  : Lowlevel_Init
* Description    : ͨGPIO
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vks118_Lowlevel_Init(void)
{
	//ͨߵƽͬӵƽת·
	//˺ݿͻƬӦ޸	
	GPIO_SetMode(VKS118_CS1_PORT, VKS118_CS1_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VKS118_CS2_PORT, VKS118_CS2_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VKS118_RD_PORT, VKS118_RD_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VKS118_WR_PORT, VKS118_WR_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VKS118_DAT_PORT, VKS118_DAT_PIN, GPIO_MODE_OUTPUT);	//ֻʾݿΪIO
//	GPIO_SetMode(VKS118_DAT_PORT, VKS118_DAT_PIN, GPIO_MODE_QUASI); //ҪΪ˫IOڶʱΪIO
		
	VKS118_CS1_H();
	VKS118_CS2_H();      
	VKS118_RD_H();  //RDŲߵƽ                  
	VKS118_WR_H();  
	VKS118_DATA_H(); 	
}
/*******************************************************************************
* Function Name  : Init
* Description    : ʼ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vks118_Init(void)
{	
	//ܽøݿͻƬӦ޸
	Vks118_Lowlevel_Init();
	//
#ifdef M0		//̬
	vks118_maxcom=1;
#else  //1/2bias 1/2duty
	vks118_maxcom=2;
#endif	
	WriteCommandVks118(OSC_ON);
	WriteCommandVks118(DISP_ON);
}
/*******************************************************************************
* Function Name  : disp_3num
* Description    : ʾ3λ
* Input          dat->3λ ʮ 
* Output         : None
* Return         : None
*******************************************************************************/
void disp_3num(unsigned int dat)
{		
	unsigned char dat8;
	
//̬
	dat8=dat/100%10;	//ʾλ
	vks118_dispram[1]&=0x0C;
	vks118_dispram[1]=shuzi_zimo[dat8]>>6;
	vks118_dispram[2]&=0x0C;
	vks118_dispram[2]|=(shuzi_zimo[dat8]&0xC0)>>4;
	vks118_dispram[3]&=0x0C;
	vks118_dispram[3]|=(shuzi_zimo[dat8]&0xF0)>>2;
	vks118_dispram[4]&=0x0C;
	vks118_dispram[4]|=(shuzi_zimo[dat8]&0xFC);
	
	dat8=dat/10%10; 	//ʾʮλ
	vks118_dispram[6]&=0x0C;
	vks118_dispram[6]=shuzi_zimo[dat8]>>6;
	vks118_dispram[7]&=0x0C;
	vks118_dispram[7]|=(shuzi_zimo[dat8]&0xC0)>>4;
	vks118_dispram[8]&=0x0C;
	vks118_dispram[8]|=(shuzi_zimo[dat8]&0xF0)>>2;
	vks118_dispram[9]&=0x0C;
	vks118_dispram[9]|=(shuzi_zimo[dat8]&0xFC);
	
	dat8=dat%10;			//ʾλ
	vks118_dispram[11]&=0x0C;
	vks118_dispram[11]=shuzi_zimo[dat8]>>6;
	vks118_dispram[12]&=0x0C;
	vks118_dispram[12]|=(shuzi_zimo[dat8]&0xC0)>>4;
	vks118_dispram[13]&=0x0C;
	vks118_dispram[13]|=(shuzi_zimo[dat8]&0xF0)>>2;
	vks118_dispram[14]&=0x0C;
	vks118_dispram[14]|=(shuzi_zimo[dat8]&0xFC);
	if(dat<100)				//С100λʾ
	{
		vks118_dispram[1]&=0x0C;
		vks118_dispram[2]&=0x0C;
		vks118_dispram[3]&=0x0C;
		vks118_dispram[4]&=0x0C;
	}
	if(dat<10) 	//С10ʮλʾ
	{
		vks118_dispram[5]&=0x0C;
		vks118_dispram[6]&=0x0C;
		vks118_dispram[7]&=0x0C;
		vks118_dispram[8]&=0x0C;
	}
	//SEG11
	Write1DataVks118_CS1(1,vks118_dispram[1]);
	Write1DataVks118_CS1(2,vks118_dispram[2]);
	Write1DataVks118_CS1(3,vks118_dispram[3]);
	Write1DataVks118_CS1(4,vks118_dispram[4]);
	Write1DataVks118_CS1(6,vks118_dispram[6]);
	Write1DataVks118_CS1(7,vks118_dispram[7]);
	Write1DataVks118_CS1(8,vks118_dispram[8]);
	Write1DataVks118_CS1(9,vks118_dispram[9]);
	Write1DataVks118_CS1(11,vks118_dispram[11]);
	Write1DataVks118_CS1(12,vks118_dispram[12]);
	Write1DataVks118_CS1(13,vks118_dispram[13]);
	Write1DataVks118_CS1(14,vks118_dispram[14]);
	//SEGͶ	
}	
/*******************************************************************************
* Function Name  : test_Main
* Description    : 
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vks118_Main(void)
{	
	Vks118_Init();
	Vks118_DisAll(0x00);
	while(1)
	{
		Vks118_DisAll(0x0f);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vks118_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		disp_3num(123);           //ʾ123
		delay_nms(3000);					//ʱ3S
		
		Vks118_DisAll(0x00);			//LCDȫ
		for(vks118_segi=0;vks118_segi<VKS118_SEGNUM;vks118_segi++)//seg
		{
			for(vks118_comi=0;vks118_comi<vks118_maxcom;vks118_comi++)//com
			{
				Vks118_DisSegComOn(vks118_segtab[vks118_segi],vks118_comi);	//LCD
				delay_nms(300);				//ʱ300mS
				Vks118_DisAll(0x00);	//LCDȫ
			}
		}
		
		Vks118_DisAll(0x0f);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		for(vks118_segi=0;vks118_segi<VKS118_SEGNUM;vks118_segi++)//seg
		{
			for(vks118_comi=0;vks118_comi<vks118_maxcom;vks118_comi++)//com
			{
				Vks118_DisSegComOff(vks118_segtab[vks118_segi],vks118_comi);	//LCDر
				delay_nms(300);				//ʱ300mS
				Vks118_DisAll(0x0f);	//LCDȫ
			}
		}
		delay_nms(1000);					//ʱ1S
		
		Vks118_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vks118_Enter_Standby();		//͹ģʽ
		delay_nms(5000);					//ʱ5S
		
		Vks118_Exit_Standby();		//˳͹ģʽ
	}
}
/************************END OF FILE****/
